#include <GL/gl.h>
#include <GL/glu.h>

extern int wallimgID;
extern int roofimgID;
extern int windowimgID;
extern int doorimgID;

void draw_cabin(void)
{
	glBindTexture(GL_TEXTURE_2D,wallimgID);

	glBegin(GL_TRIANGLES);

		//front wall

		//upper left tri
		glTexCoord2f(0.0,0.0);
		glVertex3f(-5.0,+5.0,+5.0);	//upper left vertex

		glTexCoord2f(0.0,1.0);
		glVertex3f(-5.0,-5.0,+5.0);	//lower left vertex

		glTexCoord2f(1.0,0.0);
		glVertex3f(+5.0,+5.0,+5.0);	//upper right vertex

		//lower right tri

		glTexCoord2f(0.0,1.0);
		glVertex3f(-5.0,-5.0,+5.0);	//lower left vertex

		glTexCoord2f(1.0,1.0);
		glVertex3f(+5.0,-5.0,+5.0);	//lower right vertex

		glTexCoord2f(1.0,0.0);
		glVertex3f(+5.0,+5.0,+5.0);	//upper right vertex


		//back wall

		//upper left tri
		glTexCoord2f(0.0,0.0);
		glVertex3f(+5.0,+5.0,-5.0);	//upper left vertex

		glTexCoord2f(0.0,1.0);
		glVertex3f(+5.0,-5.0,-5.0);	//lower left vertex

		glTexCoord2f(1.0,0.0);
		glVertex3f(-5.0,+5.0,-5.0);	//upper right vertex

		//lower right tri

		glTexCoord2f(0.0,1.0);
		glVertex3f(+5.0,-5.0,-5.0);	//lower left vertex

		glTexCoord2f(1.0,1.0);
		glVertex3f(-5.0,-5.0,-5.0);	//lower right vertex

		glTexCoord2f(1.0,0.0);
		glVertex3f(-5.0,+5.0,-5.0);	//upper right vertex

		//left (viewed from front) wall

		//upper left tri
		glTexCoord2f(0.0,0.0);
		glVertex3f(-5.0,+5.0,-5.0);	//upper left vertex

		glTexCoord2f(0.0,1.0);
		glVertex3f(-5.0,-5.0,-5.0);	//lower left vertex

		glTexCoord2f(1.0,0.0);
		glVertex3f(-5.0,+5.0,+5.0);	//upper right vertex

		//lower right tri

		glTexCoord2f(0.0,1.0);
		glVertex3f(-5.0,-5.0,-5.0);	//lower left vertex

		glTexCoord2f(1.0,1.0);
		glVertex3f(-5.0,-5.0,+5.0);	//lower right vertex

		glTexCoord2f(1.0,0.0);
		glVertex3f(-5.0,+5.0,+5.0);	//upper right vertex

		//right (viewed from front) wall

		//upper left tri
		glTexCoord2f(0.0,0.0);
		glVertex3f(+5.0,+5.0,+5.0);	//upper left vertex

		glTexCoord2f(0.0,1.0);
		glVertex3f(+5.0,-5.0,+5.0);	//lower left vertex

		glTexCoord2f(1.0,0.0);
		glVertex3f(+5.0,+5.0,-5.0);	//upper right vertex

		//lower right tri

		glTexCoord2f(0.0,1.0);
		glVertex3f(+5.0,-5.0,+5.0);	//lower left vertex

		glTexCoord2f(1.0,1.0);
		glVertex3f(+5.0,-5.0,-5.0);	//lower right vertex

		glTexCoord2f(1.0,0.0);
		glVertex3f(+5.0,+5.0,-5.0);	//upper right vertex

		//peak thingie (gable?) on left side
		glColor4f(0.6,0.6,0.6,1.0);

		glTexCoord2f(0.0,1.0);
		glVertex3f(+5.0,+5.0,+5.0);	//lower left vertex

		glTexCoord2f(1.0,1.0);
		glVertex3f(+5.0,+5.0,-5.0);	//lower right vertex

		glTexCoord2f(0.5,0.6);
		glVertex3f(+5.0,+9.0,0.0);	//upper middle vertex

		//peak thingie (gable?) on right side

		glTexCoord2f(0.0,1.0);
		glVertex3f(-5.0,+5.0,-5.0);	//lower left vertex

		glTexCoord2f(1.0,1.0);
		glVertex3f(-5.0,+5.0,+5.0);	//lower right vertex

		glTexCoord2f(0.5,0.6);
		glVertex3f(-5.0,+9.0,0.0);	//upper middle vertex

		glColor4f(1.0,1.0,1.0,1.0);
		//draw front roof
	glEnd();	//gotta quit to bind new texture

		glBindTexture(GL_TEXTURE_2D,roofimgID);

	glBegin(GL_TRIANGLES);

		//upper left tri
		glTexCoord2f(0.0,0.0);
		glVertex3f(-5.0,+9.0,+0.0);	//upper left vertex

		glTexCoord2f(0.0,1.0);
		glVertex3f(-5.0,+5.0,+5.0);	//lower left vertex

		glTexCoord2f(1.0,0.0);
		glVertex3f(+5.0,+9.0,+0.0);	//upper right vertex

		//lower right tri

		glTexCoord2f(0.0,1.0);
		glVertex3f(-5.0,+5.0,+5.0);	//lower left vertex

		glTexCoord2f(1.0,1.0);
		glVertex3f(+5.0,+5.0,+5.0);	//lower right vertex

		glTexCoord2f(1.0,0.0);
		glVertex3f(+5.0,+9.0,+0.0);	//upper right vertex

		//draw back roof

		//upper left tri
		glTexCoord2f(0.0,0.0);
		glVertex3f(+5.0,+9.0,+0.0);	//upper left vertex

		glTexCoord2f(0.0,1.0);
		glVertex3f(+5.0,+5.0,-5.0);	//lower left vertex

		glTexCoord2f(1.0,0.0);
		glVertex3f(-5.0,+9.0,+0.0);	//upper right vertex

		//lower right tri

		glTexCoord2f(0.0,1.0);
		glVertex3f(+5.0,+5.0,-5.0);	//lower left vertex

		glTexCoord2f(1.0,1.0);
		glVertex3f(-5.0,+5.0,-5.0);	//lower right vertex

		glTexCoord2f(1.0,0.0);
		glVertex3f(-5.0,+9.0,+0.0);	//upper right vertex

	//draw windows
	glEnd();	//gotta quit to bind new texture

		glBindTexture(GL_TEXTURE_2D,windowimgID);
		//glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL);

	glBegin(GL_TRIANGLES);

#define WINBOTTOM 1.30
#define WINTOP 3.0
		//one window in back

		//upper left tri
		glTexCoord2f(0.0,0.0);
		glVertex3f(+1.0,WINTOP,-5.1);	//upper left vertex

		glTexCoord2f(0.0,1.0);
		glVertex3f(+1.0,WINBOTTOM,-5.1);	//lower left vertex

		glTexCoord2f(1.0,0.0);
		glVertex3f(-1.0,WINTOP,-5.1);	//upper right vertex

		//lower right tri

		glTexCoord2f(0.0,1.0);
		glVertex3f(+1.0,WINBOTTOM,-5.1);	//lower left vertex

		glTexCoord2f(1.0,1.0);
		glVertex3f(-1.0,WINBOTTOM,-5.1);	//lower right vertex

		glTexCoord2f(1.0,0.0);
		glVertex3f(-1.0,WINTOP,-5.1);	//upper right vertex

		//one window on each end

		//upper left tri
		glTexCoord2f(0.0,0.0);
		glVertex3f(+5.1,WINTOP,+1.0);	//upper left vertex

		glTexCoord2f(0.0,1.0);
		glVertex3f(+5.1,WINBOTTOM,+1.0);	//lower left vertex

		glTexCoord2f(1.0,0.0);
		glVertex3f(+5.1,WINTOP,-1.0);	//upper right vertex

		//lower right tri

		glTexCoord2f(0.0,1.0);
		glVertex3f(+5.1,WINBOTTOM,+1.0);	//lower left vertex

		glTexCoord2f(1.0,1.0);
		glVertex3f(+5.1,WINBOTTOM,-1.0);	//lower right vertex

		glTexCoord2f(1.0,0.0);
		glVertex3f(+5.1,WINTOP,-1.0);	//upper right vertex

		//two windows in front

		//window to left of door

		//upper left tri
		glTexCoord2f(0.0,0.0);
		glVertex3f(-4.0,WINTOP,+5.1);	//upper left vertex

		glTexCoord2f(0.0,1.0);
		glVertex3f(-4.0,WINBOTTOM,+5.1);	//lower left vertex

		glTexCoord2f(1.0,0.0);
		glVertex3f(-2.0,WINTOP,+5.1);	//upper right vertex

		//lower right tri

		glTexCoord2f(0.0,1.0);
		glVertex3f(-4.0,WINBOTTOM,+5.1);	//lower left vertex

		glTexCoord2f(1.0,1.0);
		glVertex3f(-2.0,WINBOTTOM,+5.1);	//lower right vertex

		glTexCoord2f(1.0,0.0);
		glVertex3f(-2.0,WINTOP,+5.1);	//upper right vertex

		//window to right of door

		//upper left tri
		glTexCoord2f(0.0,0.0);
		glVertex3f(+2.0,WINTOP,+5.1);	//upper left vertex

		glTexCoord2f(0.0,1.0);
		glVertex3f(+2.0,WINBOTTOM,+5.1);	//lower left vertex

		glTexCoord2f(1.0,0.0);
		glVertex3f(+4.0,WINTOP,+5.1);	//upper right vertex

		//lower right tri

		glTexCoord2f(0.0,1.0);
		glVertex3f(+2.0,WINBOTTOM,+5.1);	//lower left vertex

		glTexCoord2f(1.0,1.0);
		glVertex3f(+4.0,WINBOTTOM,+5.1);	//lower right vertex

		glTexCoord2f(1.0,0.0);
		glVertex3f(+4.0,WINTOP,+5.1);	//upper right vertex

	//draw door
	glEnd();	//gotta quit to bind new texture

		glBindTexture(GL_TEXTURE_2D,doorimgID);

	glBegin(GL_TRIANGLES);

		//upper left tri
		glTexCoord2f(0.0,0.0);
		glVertex3f(-1.0,+3.8,+5.1);	//upper left vertex

		glTexCoord2f(0.0,1.0);
		glVertex3f(-1.0,-1.0,+5.1);	//lower left vertex

		glTexCoord2f(1.0,0.0);
		glVertex3f(+1.0,+3.8,+5.1);	//upper right vertex

		//lower right tri

		glTexCoord2f(0.0,1.0);
		glVertex3f(-1.0,-1.0,+5.1);	//lower left vertex

		glTexCoord2f(1.0,1.0);
		glVertex3f(+1.0,-1.0,+5.1);	//lower right vertex

		glTexCoord2f(1.0,0.0);
		glVertex3f(+1.0,+3.8,+5.1);	//upper right vertex
	glEnd();
}
